<template lang="pug">
  v-app
    v-app-bar(app, color="primary", dark, height=56)
      v-avatar.mx-2
        img(src="favicon.ico")
      v-toolbar-title.text-truncate {{title}}
      v-spacer
      v-menu(v-if="!download.status")
        template(v-slot:activator="{on}")
          v-btn(icon, v-on="on")
            v-icon mdi-download
        v-list
          v-list-item(@click="downloadFiles()") Download All
          v-list-item(@click="downloadFiles(true)") Download New
      template(v-else)
        small.pr-1 {{download.current}}/{{download.total}} 
        v-progress-circular(:value="download.current/download.total*100", :rotate="-90")
      v-btn(icon, @click="setView('list')", v-if="view=='icon'")
        v-icon mdi-view-grid
      v-btn(icon, @click="setView('icon')", v-else)
        v-icon mdi-view-list

    v-content(v-if="maintenance")
      .text-center.display-1.pa-8 Maintenance
      .text-center We are sorry but KiraFan Assets is in maintenance.
      .text-center It will be open at {{maintenance}} on schedule.
      .text-center Please come back later!

    v-content(v-else, style="min-height: 100vh")
      v-breadcrumbs(:items="breadcrumbs", divider="/")
      .text-center(v-if="loading")
        v-progress-circular(indeterminate, color="primary")
      IconView(:files="files", :error="error", v-else-if="view=='icon'")
      ListView(:files="files", :error="error", v-else)

    v-footer(dark, padless)
      v-card.primary(tile, style="width: 100%")
        .ma-auto.pa-6(style="max-width: 768px")
          v-row
            v-col(cols=12, sm=6)
              v-card-title.px-0 KiraFan Assets
              v-card-subtitle.px-0 Kirara Fantasia Assets Browser
              v-card-text.px-0.py-1
                | Contribute to KiraFan Assets on
                a.white--text(href="https://gitlab.com/kirafan/assets/browser", target="_blank")
                  v-icon.px-1 mdi-gitlab
                  | GitLab
                | .

            v-col(cols=6, sm=3)
              v-card-title.px-0 Projects
              v-card-text.px-0.py-1: a.white--text(href="https://wiki.kirafan.moe", target="_blank")
                | KiraFan Wiki
              v-card-text.px-0.py-1: a.white--text(href="https://calc.kirafan.moe", target="_blank")
                | KiraFanCalc
              v-card-text.px-0.py-1: a.white--text(target="_blank")
                | Morpheus

            v-col(cols=6, sm=3)
              v-card-title.px-0 Contact
              v-card-text.px-0.py-1: a.white--text(href="https://twitter.com/nilcric", target="_blank")
                v-icon.px-1 mdi-twitter
                | Circle Lin
</template>

<script>
import axios from 'axios';
import JSZip from 'jszip';
import fileSaver from 'file-saver';
import { nextTick } from 'q';
import ListView from './ListView';
import IconView from './IconView';

export default {
  name: 'App',
  data() {
    return {
      view: localStorage['view'] || 'list',
      scrollTops: {},
      loading: false,

      files: [],
      error: false,

      maintenance: false, // "18:00 JST, November 27",

      download: {
        status: 0,
        total: 0,
        current: 0,
      }
    };
  },
  components: { ListView, IconView },
  computed: {
    title() {
      if (this.$route.path == '/') {
        return 'KiraFan Assets';
      }
      const paths = this.$route.path.split('/');
      return paths[paths.length - 1] || paths[paths.length - 2];
    },
    path() {
      const p = this.$route.path;
      if (p.endsWith('/')) {
        return p;
      }
      return p + '/';
    },
    back() {
      return this.path.split('/').slice(0, -2).join('/') + '/';
    },
    breadcrumbs() {
      const paths = this.path.split('/');
      let items = [];
      for (let i in paths) {
        items.push({
          text: i == 0 ? 'assets' : paths[i],
          to: i == 0 ? '/' : paths.slice(0, parseInt(i) + 1).join('/'),
          exact: true
        });
      }
      return items;
    },
  },
  methods: {
    downloadFiles(onlyNew) {
      const self = this;

      const promises = [];
      const zip = new JSZip();

      const folder = this.title;
      const files = this.files.filter(file =>
        file.type != 'dir' &&
        (!onlyNew || file.new));

      this.download.status = 1;
      this.download.total = files.length;
      this.download.current = 0;

      function newPromise() {
        const file = files.pop();
        return file && axios({
          method: 'get',
          url: file.link,
          responseType: 'blob',
        }).then(data => {
          const blob = data.data;
          const fileName = file.name + '.' + file.type;
          zip.file(fileName, blob, { binary: true });
          self.download.current += 1;
        }).catch(() => {
          return;
        });
      }

      function next() {
        const promise = newPromise();
        if (promise) {
          // iter
          promises.push(promise);
          promise.then(() => next());
        } else if (self.download.status != 1) {
          // last iter over
          return;
        } else {
          // last iter
          self.download.status = 2;
          Promise.all(promises).then(() => {
            zip.generateAsync({ type: 'blob' }).then(content => {
              fileSaver.saveAs(content, `${folder}.zip`);
            });
            self.download.status = 0;
          });
        }
      }

      for (let i = 0; i < 4; i++) {
        next();
      }
    },
    setView(view) {
      this.view = view;
      localStorage['view'] = view;
    },
    changeRoute(from) {
      if (this.maintenance) {
        return;
      }
      if (from) {
        const fromPath = from.path.endsWith('/') ? from.path : `${from.path}/`;
        const scrollTop = document.documentElement.scrollTop || document.body.scrollTop || window.pageYOffset;
        this.scrollTops[fromPath] = scrollTop;
      }

      this.loading = true;
      nextTick(() => this.$vuetify.goTo(0, { duration: 0 }));
      const requestPath = this.path;
      this.files = [];
      let folders = new Set();
      for (let bucket of this.$buckets) {
        if (this.path.startsWith(bucket.path)) {
          let uri = this.path.slice(bucket.path.length);

          axios
            .get(`https://${bucket.name}-asset.kirafan.cn/${uri}/index.json`)
            .then(response => {
              if (requestPath == this.path) {
                response.data.forEach(file => this.files.push(file));
                this.loading = false;
                nextTick(() => this.$vuetify.goTo(this.scrollTops[this.path] || 0, { duration: 0 }));
              }
            })
            .catch(() => true);
        } else if (bucket.path.startsWith(this.path)) {
          let names = bucket.path.slice(this.path.length).split('/');
          folders.add(names[0]);
        }
      }
      for (let folder of folders) {
        this.files.push({ name: folder, type: 'dir', new: true });
      }
    },
  },
  mounted() {
    this.changeRoute();
  },
  watch: {
    $route(to, from) {
      this.changeRoute(from);
    }
  }
};
</script>

<style>
a {
  text-decoration: none;
}
</style>